IRremoteESP8266: IRCarrierAc64 Class Reference

IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRCarrierAc64 Class Reference

Class for handling detailed Carrier 64 bit A/C messages. More...

`#include <ir_Carrier.h>`

Collaboration diagram for IRCarrierAc64:
[legend]

## Public Member Functions

| IRCarrierAc64 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | stateReset ()
| Reset the internal state to a fixed known good state. More...
void | send (const uint16_t repeat=kCarrierAc64MinRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin ()
| Set up hardware to be able to send a message. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
void | setTemp (const uint8_t temp)
| Set the temp in deg C. More...
uint8_t | getTemp (void) const
| Get the current temperature from the internal state. More...
void | setSwingV (const bool on)
| Set the Vertical Swing mode of the A/C. More...
bool | getSwingV (void) const
| Get the Vertical Swing mode of the A/C. More...
void | setSleep (const bool on)
| Set the Sleep mode of the A/C. More...
bool | getSleep (void) const
| Get the Sleep mode of the A/C. More...
void | setFan (const uint8_t speed)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setOnTimer (const uint16_t nr_of_mins)
| Set the On Timer time. More...
uint16_t | getOnTimer (void) const
| Get the current On Timer time. More...
void | setOffTimer (const uint16_t nr_of_mins)
| Set the Off Timer time. More...
uint16_t | getOffTimer (void) const
| Get the current Off Timer time. More...
uint64_t | getRaw (void)
| Get a copy of the internal state as a valid code for this protocol. More...
void | setRaw (const uint64_t state)
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the A/C state to it's common stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the internal state into a human readable string. More...

## Static Public Member Functions

static uint8_t | calcChecksum (const uint64_t state)
| Calculate the checksum for a given state. More...
static bool | validChecksum (const uint64_t state)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a standard A/C mode into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode to it's common stdAc::opmode_t equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions

void | checksum (void)
| Calculate and set the checksum values for the internal state. More...
void | _cancelOnTimer (void)
| Clear the On Timer enable bit. More...
void | _cancelOffTimer (void)
| Clear the Off Timer enable bit. More...

## Private Attributes

IRsend | _irsend
| Instance of the IR send class. More...
CarrierProtocol | _

## Detailed Description

Class for handling detailed Carrier 64 bit A/C messages.

## Constructor & Destructor Documentation

## ◆ IRCarrierAc64()

IRCarrierAc64::IRCarrierAc64 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ _cancelOffTimer()

void IRCarrierAc64::_cancelOffTimer | ( | void |  | ) |

private

Clear the Off Timer enable bit.

## ◆ _cancelOnTimer()

void IRCarrierAc64::_cancelOnTimer | ( | void |  | ) |

private

Clear the On Timer enable bit.

## ◆ begin()

void IRCarrierAc64::begin | ( |  | ) |

Set up hardware to be able to send a message.

## ◆ calcChecksum()

uint8_t IRCarrierAc64::calcChecksum | ( | const uint64_t | state | ) |

static

Calculate the checksum for a given state.

Parameters

  [in] | state | The value to calc the checksum of.

Returns
  The 4-bit checksum stored in a uint_8.

## ◆ calibrate()

int8_t IRCarrierAc64::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRCarrierAc64::checksum | ( | void |  | ) |

private

Calculate and set the checksum values for the internal state.

## ◆ convertFan()

uint8_t IRCarrierAc64::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRCarrierAc64::convertMode | ( | const stdAc::opmode_t | mode | ) |

static

Convert a standard A/C mode into its native mode.

Parameters

  [in] | mode | A stdAc::opmode_t to be converted to it's native equivalent.

Returns
  The corresponding native mode.

## ◆ getFan()

uint8_t IRCarrierAc64::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed.

## ◆ getMode()

uint8_t IRCarrierAc64::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getOffTimer()

uint16_t IRCarrierAc64::getOffTimer | ( | void |  | ) | const

Get the current Off Timer time.

Returns
  The number of minutes it is set for. 0 means it's off.

Note
  The A/C protocol only supports one hour increments.

## ◆ getOnTimer()

uint16_t IRCarrierAc64::getOnTimer | ( | void |  | ) | const

Get the current On Timer time.

Returns
  The number of minutes it is set for. 0 means it's off.

Note
  The A/C protocol only supports one hour increments.

## ◆ getPower()

bool IRCarrierAc64::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint64_t IRCarrierAc64::getRaw | ( | void |  | ) |

Get a copy of the internal state as a valid code for this protocol.

Returns
  A valid code for this protocol based on the current internal state.

## ◆ getSleep()

bool IRCarrierAc64::getSleep | ( | void |  | ) | const

Get the Sleep mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwingV()

bool IRCarrierAc64::getSwingV | ( | void |  | ) | const

Get the Vertical Swing mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getTemp()

uint8_t IRCarrierAc64::getTemp | ( | void |  | ) | const

Get the current temperature from the internal state.

Returns
  The current temperature in Celsius.

## ◆ off()

void IRCarrierAc64::off | ( | void |  | ) |

Change the power setting to Off.

## ◆ on()

void IRCarrierAc64::on | ( | void |  | ) |

Change the power setting to On.

## ◆ send()

void IRCarrierAc64::send | ( | const uint16_t | repeat = `kCarrierAc64MinRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setFan()

void IRCarrierAc64::setFan | ( | const uint8_t | speed | ) |

Set the speed of the fan.

Parameters

  [in] | speed | The desired setting.

## ◆ setMode()

void IRCarrierAc64::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setOffTimer()

void IRCarrierAc64::setOffTimer | ( | const uint16_t | nr_of_mins | ) |

Set the Off Timer time.

Parameters

  [in] | nr_of_mins | Number of minutes to set the timer to. (< 60 is disable).

Note
  The A/C protocol only supports one hour increments.

## ◆ setOnTimer()

void IRCarrierAc64::setOnTimer | ( | const uint16_t | nr_of_mins | ) |

Set the On Timer time.

Parameters

  [in] | nr_of_mins | Number of minutes to set the timer to. (< 60 is disable).

Note
  The A/C protocol only supports one hour increments.

## ◆ setPower()

void IRCarrierAc64::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRCarrierAc64::setRaw | ( | const uint64_t | state | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | state | A valid code for this protocol.

## ◆ setSleep()

void IRCarrierAc64::setSleep | ( | const bool | on | ) |

Set the Sleep mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setSwingV()

void IRCarrierAc64::setSwingV | ( | const bool | on | ) |

Set the Vertical Swing mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setTemp()

void IRCarrierAc64::setTemp | ( | const uint8_t | temp | ) |

Set the temp in deg C.

Parameters

  [in] | temp | The desired temperature in Celsius.

## ◆ stateReset()

void IRCarrierAc64::stateReset | ( |  | ) |

Reset the internal state to a fixed known good state.

Note
  The state is powered off.

## ◆ toCommon()

stdAc::state_t IRCarrierAc64::toCommon | ( | void |  | ) | const

Convert the A/C state to it's common stdAc::state_t equivalent.

Returns
  A stdAc::state_t state.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRCarrierAc64::toCommonFanSpeed | ( | const uint8_t | speed | ) |

static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRCarrierAc64::toCommonMode | ( | const uint8_t | mode | ) |

static

Convert a native mode to it's common stdAc::opmode_t equivalent.

Parameters

  [in] | mode | A native operation mode to be converted.

Returns
  The corresponding common stdAc::opmode_t mode.

## ◆ toString()

String IRCarrierAc64::toString | ( | void |  | ) | const

Convert the internal state into a human readable string.

Returns
  The current internal state expressed as a human readable String.

## ◆ validChecksum()

bool IRCarrierAc64::validChecksum | ( | const uint64_t | state | ) |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

CarrierProtocol IRCarrierAc64::_

private

## ◆ _irsend

IRsend IRCarrierAc64::_irsend

private

Instance of the IR send class.

The documentation for this class was generated from the following files:

- src/ir_Carrier.h
- src/ir_Carrier.cpp